﻿Imports System.Data.EntityClient
Imports HuagatiEFProfiler

Partial Public Class AWEntities
    Private _profiler As HuagatiEFProfiler.EFProfiler = Nothing

    Public Sub New(ByVal enableProfiling As Boolean)
        Me.New(enableProfiling, "name=AWEntities")
    End Sub

    Public Sub New(ByVal enableProfiling As Boolean, ByVal connectionString As String)
        Me.New(EFProfiler.GetConnection(enableProfiling, connectionString))
        Dim profilerOutput =
            System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.Personal),
                                   "EFProfiler\Samples")
        '#If DEBUG Then
        _profiler = New HuagatiEFProfiler.EFProfiler(Me, profilerOutput,
                                                     Nothing,
                                                     HuagatiEFProfiler.ExecutionPlanMode.Actual,
                                                     False)
        '#Else
        ''_profiler = new HuagatiEFProfiler.EFProfiler(this, profilerOutput,
        '                                                    new HuagatiEFProfiler.Filters.PageReadFilter(1000),
        '                                                    HuagatiEFProfiler.ExecutionPlanMode.Actual,false)
        '#End If
        AddHandler _profiler.LogError, AddressOf EFProfiler_LogError
    End Sub

    Private Sub EFProfiler_LogError(ByVal sender As Object, ByVal e As EventArgs)
        Dim args = CType(e, HuagatiEFProfiler.LogErrorEventArgs)
        Debug.Assert(False, "Profiler logging failed - " & args.ErrorMessage)
    End Sub

    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        If _profiler IsNot Nothing Then
            _profiler.Dispose()
        End If
        MyBase.Dispose(disposing)
    End Sub
End Class
