﻿Friend Class Program
    Shared Sub Main(ByVal args() As String)
        'ToTraceString()
        'Intellitrace()
        'TracingProfiler()
        EFProf()
        ' HuagatiProfiling()  'comment out the DBProviderFactores in app.config
        'to run this. You'll need to skip the TracingProfiler
        'method (which will fail because of the change
        'to the app.config file
    End Sub

    Private Shared Sub HuagatiProfiling()
        'you will need to comment out the DbProviderFactories
        'in app.config (they are there for EFTracing) in order for this to work
        Using context = New AWEntities(True)
            Dim query = From c In context.Customers
                        Select c
            Dim custList = query.Take(10).ToList() 'execute query
            Dim custFirst = custList(0)
            Dim orderCount = custFirst.Orders.Count 'lazy load
            context.ContextOptions.LazyLoadingEnabled = False
            Dim custSecond = custList(4)
            custSecond.Orders.Load() 'explicit load
            custSecond.ModifiedDate = Date.Now
            context.SaveChanges() 'update

            'call function (stored procedure) 
            Dim orders = context.GetCustomerOrdersForId(custList(2).CustomerID)
        End Using
    End Sub

    Private Shared Sub EFProf()
        HibernatingRhinos.Profiler.Appender.EntityFramework.EntityFrameworkProfiler.Initialize()
        Using context = New AWEntities()

            Dim query = From c In context.Customers
                        Select c
            Dim custList = query.Take(10).ToList() 'execute query
            Dim custFirst = custList(0)
            Dim orderCount = custFirst.Orders.Count 'lazy load
            context.ContextOptions.LazyLoadingEnabled = False
            Dim custSecond = custList(4)
            custSecond.Orders.Load() 'explicit load
            custSecond.ModifiedDate = Date.Now
            context.SaveChanges() 'update

            'call function (stored procedure) 
            Dim orders = context.GetCustomerOrdersForId(custList(2).CustomerID)

        End Using

    End Sub

    Private Shared Sub Intellitrace()
        Using context = New AWEntities()

            Dim query = From c In context.Customers
                        Select c
            Dim custList = query.Take(10).ToList() 'execute query
            Dim custFirst = custList(0)
            Dim orderCount = custFirst.Orders.Count 'lazy load
            context.ContextOptions.LazyLoadingEnabled = False
            Dim custSecond = custList(1)
            custSecond.Orders.Load() 'explicit load
            custSecond.ModifiedDate = Date.Now
            context.SaveChanges() 'update

            'call function (stored procedure) 
            Dim orders = context.GetCustomerOrdersForId(custList(2).CustomerID)

        End Using
    End Sub

    Private Shared Sub ToTraceString()
        Using context = New AWEntities()
            Dim query = From c In context.Customers
                        Where c.CustomerID = 3
                        Select c
            Dim objectQuery = TryCast(query, Objects.ObjectQuery)
            Console.WriteLine(objectQuery.ToTraceString())
        End Using
    End Sub

    Private Shared Sub TracingProfiler()
        'be sure that the the DbProviderFactories
        'in app.config is NOT commented  in order for this to work
        ' disable global logging to console
        EFTracingProviderConfiguration.LogToConsole = False

        Using logFile As TextWriter = File.CreateText("sqllogfile.txt")

            Using context = New ExtendedAWEntities()
                context.Log = logFile

                Dim query = From c In context.Customers
                            Select c
                Dim custList = query.Take(10).ToList() 'execute query
                Dim custFirst = custList(0)
                Dim orderCount = custFirst.Orders.Count 'lazy load
                context.ContextOptions.LazyLoadingEnabled = False
                Dim custSecond = custList(1)
                custSecond.Orders.Load() 'explicit load
                custSecond.ModifiedDate = Date.Now
                context.SaveChanges() 'update

                'call function (stored procedure) 
                Dim orders = context.GetCustomerOrdersForId(custList(2).CustomerID)
            End Using
        End Using
        Console.WriteLine("LOG FILE CONTENTS:")
        Console.WriteLine(File.ReadAllText("sqllogfile.txt"))
    End Sub
End Class
